/*------------------------------------------------------------------------------------*/
/*                                                                                    */
/*    Copyright (C) 2008, 2009 and 2010, Georges Qunot, LIG-CNRS.                    */
/*    Version 1.02 Last revision: March 31, 2010.                                     */
/*                                                                                    */
/*    This file is part of KNNLSB (K Nearest Neighbors Linear Scan Baseline).         */
/*                                                                                    */
/*    KNNLSB is free software: you can redistribute it and/or modify                  */
/*    it under the terms of the GNU Lesser General Public License as                  */
/*    published by the Free Software Foundation, either version 3 of                  */
/*    the License, or (at your option) any later version.                             */
/*                                                                                    */
/*    KNNLSB is distributed in the hope that it will be useful,                       */
/*    but WITHOUT ANY WARRANTY; without even the implied warranty of                  */
/*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the                   */
/*    GNU Lesser General Public License for more details.                             */
/*                                                                                    */
/*    You should have received a copy of the GNU Lesser General Public                */
/*    License along with KNNLSB.  If not, see <http://www.gnu.org/licenses/>.         */
/*                                                                                    */
/*------------------------------------------------------------------------------------*/

#define fdata float
#define FDATA_MAX FLT_MAX

/*------------------------------------------------------------------------------------*/

#include <sched.h>
#include <pthread.h>
#include <stdlib.h>
#include <stdio.h>
#include <float.h>
#include <math.h>
#include <string.h>
#include <sys/time.h>

/*------------------------------------------------------------------------------------*/

typedef struct {
  int k;
  fdata d;
} KEY;

typedef struct {
  KEY **key;
  fdata **ma;
  fdata **mb;
  fdata *sa;
  fdata *sb;
  fdata *dm;
  size_t la;
  size_t ha;
  size_t lb;
  size_t hb;
  size_t nc;
  size_t nk;
  size_t np;
  int dc;
} KNNPARAMS;

size_t UsedMemory();
size_t MaxUsedMemory();
void *malloc1a(size_t n0, size_t size);
void free1a(void *v1, size_t n0, size_t size);
void *malloc2a(size_t n0, size_t n1, size_t size);
void free2a(void *v2, size_t n0, size_t n1, size_t size);

size_t get_nb_cores();
size_t get_cache_size();

fdata *getnorm(fdata **m, size_t n, size_t nc, int dc);
KEY **knnp(fdata **ma, fdata **mb, fdata *sa, size_t na, size_t nb, size_t nc,
size_t nk, size_t np, size_t cs, int dc, int sta);

KEY **knnc(fdata **ma, fdata **mb, size_t na, size_t nb, size_t nc, size_t nk, int dc,
int sta);
void knncheck(KEY **key0, KEY **key1, size_t nb, size_t nk);

/*------------------------------------------------------------------------------------*/
